#!/usr/local/bin/python

# otp.py (One Time Pad)
# otp.py was written 2001-04-18 by Adam Gurno (a_gurno@yahoo.com) 
# otp.py is hereby placed in the public domain.  Share and enjoy.
#
## Rather important note #######################################################
# 
# The documentation for the random lib emphasizes that random is not truly
# random and that it is entirely unsuited for cryptographic purposes. 8^)
# What this means is that random is just as random as any other software-based
# randomizer(*) and if you are trying to overthrow a government you should not 
# use it as an otp generator.
# 
# see: http://python.org/doc/current/lib/module-random.html
# * - There are a multitude of ways to generate OTPs.  These 'random' functions
# are just one and not a very good one at that.

import random, string, sys

def otp(length = 64):
	__doc__ = "Generates a otp of len 'length'.  Defaults to 64"
	ret_str = ""
	for spam in range (0, length):
		ret_str = ret_str + random.choice(string.uppercase)

	return ret_str

if __name__ == '__main__':
	if (len(sys.argv) != 2):
		print "Usage: %s otp_length" % sys.argv[0]
		sys.exit(1)
	eggs = otp(int(sys.argv[1]))
	print eggs
